.386
.model flat,stdcall
option casemap:none
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdiplus.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdiplus.lib
include gdiplus_structures_ver1.inc
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\macros\macros.asm
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
S macro	szData:VARARG 
	LOCAL Buff
.data
	ifidni <szData>,<>            
		Buff db 0        
	else            
		Buff db szData,0
	endif
.code
	exitm <OFFSET Buff>
endm
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.DATA
	GdiPlusSI	GdiplusStartupInput	{1,NULL,FALSE,FALSE} ;default
	penWidth	REAL4 1.2f

	pPoint		PointF {500.0, 240.0}
			PointF {300.0, 280.0}
			PointF {400.0,320.0}
			PointF {250.0,360.0}
			PointF {290.0,395.726405817773}
			PointF {300.0,313.562336350022}
			PointF {310.0,380.236093561674}
			PointF {320.0,383.205669204542}
			PointF {330.0,347.408057803263}
			PointF {340.0,379.066485842909}
			PointF {350.0,496.488263212844}
			PointF {360.0,495.763813340541}
			PointF {370.0,530.941617453638}
			PointF {380.0,312.155812175893}
			PointF {390.0,606.762179445474}
			PointF {400.0,255.8951339964604}
			PointF {410.0,430.641779238024}
			PointF {420.0,217.4446966322051}
		
		
	dw0_001		DWORD 0.001
	dw1_0		DWORD 1.0
	lastTime	DWORD 0.0
	framesPerSecond	DWORD 0.0
      animation_counter DWORD 0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.DATA?
	hInstance	HINSTANCE ?
	CommandLine	LPSTR ?
	hDC		DWORD ?
	hGDIplus	DWORD ?
	hWind		HWND ?

	hGraphics	DWORD ?
	hBrush		DWORD ?
	hPen		DWORD ?
	strFrameRate	db 50 dup(?)
	uszBuffer	db 200 dup (?)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.CODE
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Animate proc 

	.if animation_counter < 34*4
		add	animation_counter, 4
	.else
		xor	eax, eax
		mov	animation_counter, eax
	.endif

	lea	eax, pPoint
	add	eax, animation_counter

	mov	ecx, dword ptr [eax]
	xchg	ecx, dword ptr [eax+4]
	mov	dword ptr [eax], ecx

	ret

Animate endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CalculateFrameRate proc 
	LOCAL currentTime :DWORD
	LOCAL temp:QWORD
	LOCAL intOut:DWORD
 
	invoke	GetTickCount
	mov	dword ptr temp, eax
	mov	dword ptr temp+4, 0
	fild	temp
	fmul	dw0_001
	fstp	currentTime

	fld	framesPerSecond
	fadd	dw1_0
	fstp	framesPerSecond
	
	fld	currentTime
	fsub	lastTime
	fcomp	dw1_0
	fstsw	ax
	test	ah, 041h   
	
	.if ZERO?   
	    	m2m	lastTime, currentTime
 	
		fld	framesPerSecond
		fist	intOut
		invoke	wsprintf, addr strFrameRate, S("  FPS: %d       "), intOut
		mov	framesPerSecond, 0;
	.endif
	ret

CalculateFrameRate endp 
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DrawGradient  proc

	invoke	Animate
	invoke	GdipGraphicsClear , hGraphics,  0ffffffffh
	invoke	Sleep, 500

	invoke	GdipSetPenColor, hPen, ColorsMagenta
	invoke	GdipSetPenWidth, hPen, penWidth
	invoke	GdipDrawLines, hGraphics, hPen, addr pPoint, 18

	lea	ebx, strFrameRate
	lea	edx, uszBuffer
	mov	ecx, -1
@@:
	mov al, byte ptr [ebx]
	.IF al != 0
		mov byte ptr [edx], al
		mov byte ptr [edx+1], 0
		inc ebx
		add edx, 2
		add ecx, 1
		jmp @B
	.endif
	mov dword ptr [edx], 0
	
	ret

DrawGradient  endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL ps:PAINTSTRUCT

	.if uMsg == WM_ERASEBKGND 
		mov	eax, 1
		ret	
	
	.elseif uMsg == WM_PAINT
 		invoke	DrawGradient
		xor	eax,eax
		ret

	.elseif uMsg == WM_CREATE
		invoke	GetDC, NULL
		mov	hDC,eax
		invoke	GdiplusStartup,ADDR hGDIplus,ADDR GdiPlusSI,NULL

		invoke	GdipCreateFromHDC, hDC, addr hGraphics
		invoke	GdipCreatePen1, 0FFFF00FFh, penWidth, 2, addr hPen
		invoke	GdipSetPenLineJoin, hPen, 0
		invoke	GdipCreateSolidFill, 0FF00FFFFh, addr hBrush
		ret
	
	.elseif uMsg == WM_DESTROY
		.if hGDIplus != 0
			invoke	GdipDeleteBrush, hBrush
			invoke	GdipDeletePen, hPen
			invoke	GdipDeleteGraphics, hGraphics
			invoke	GdiplusShutdown,hGDIplus
		.endif
		invoke	ReleaseDC, NULL, hDC
		invoke	PostQuitMessage,NULL
		ret
	.elseif uMsg==WM_KEYUP
		.if eax == 0Dh	|| 1BH			;ESCAPE KEY
			invoke	PostQuitMessage,NULL
		.endif
	.else 
		invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc   :WNDCLASSEX
	LOCAL msg  :MSG
	local hWnd :HWND
    
	mov	wc.cbSize,sizeof WNDCLASSEX
	mov	wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov	wc.lpfnWndProc,offset WndProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,NULL
	m2m	wc.hInstance,hInst
	mov	wc.hbrBackground,0	;COLOR_BTNFACE+1            
	mov	wc.lpszMenuName,NULL
	mov	wc.lpszClassName,S("test")
	invoke	LoadIcon,hInst,100
	mov	wc.hIcon,eax
	mov	wc.hCursor,0
	mov	wc.hIconSm,0
	invoke	RegisterClassEx, ADDR wc
	invoke	CreateWindowEx,NULL,S("test"),S("test"),WS_POPUP or WS_POPUPWINDOW,\
			0,0,800,800,NULL,NULL,hInst,NULL
	mov	hWnd,eax
	invoke	ShowWindow,hWnd,SW_MAXIMIZE
	invoke	UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov eax,msg.wParam
	ret
WinMain ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start:
	invoke	MessageBox,NULL,S("ESC for exit"),S("test"),MB_OK
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke	ExitProcess, eax
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

end start

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
